#include <clip.h>
#include "ym2151.h"
#include "mdx.h"
#include "mdx2151.h"

#define FM_CLOCK	(4*1000*1000)		/* FM̓NbN=4MHz(X68000dl) */
#define PB_RATE_1	(16*1000)		/* Đ[g=16KHz(P/ECEdl) */
#define PB_RATE		(PB_RATE_1/PB_RATE_DIV)	/* ۂ̍Đ[g */
#define PB_RATE_DIV	5/*4or5or8*/		/* ̂߉1ɍĐ[g邩H() */
#define CB_RATE		50			/* bR[obNH */
#define BLKS		(PB_RATE_1/CB_RATE)	/* R[obN񓖂̃Tv */

#define MAX_SONG_SIZE	(32*1024)		/* MDXt@Cǂݍ݃obt@TCY */

extern MDX_DATA mdx_data;
extern unsigned char mdx_song[MAX_SONG_SIZE];
extern unsigned short irq_cnt;

int stream_callback(short* wbuff, int param);
void stream_callback_sub(short* dst, short* src);

/**INLINE**/ void refresh_EG( YM2151 *chip, OscilRec * op);

/**static**/ int  set_new_event(MDX_DATA*mdx, int );
/**static**/ void set_tempo(MDX_DATA*mdx, int );
/**static**/ void note_off(MDX_DATA*mdx, int );
/**static**/ void note_on(MDX_DATA*mdx, int, int );
/**static**/ void set_volume(MDX_DATA*mdx, int, int );
/**static**/ void inc_volume(MDX_DATA*mdx, int );
/**static**/ void dec_volume(MDX_DATA*mdx, int );
/**static**/ void set_phase(MDX_DATA*mdx, int, int );
/**static**/ void set_keyoff(MDX_DATA*mdx, int );
/**static**/ void set_voice(MDX_DATA*mdx, int, int );
/**static**/ void set_quantize(MDX_DATA*mdx, int, int );
/**static**/ void set_detune(MDX_DATA*mdx, int, int, int );
/**static**/ void set_portament(MDX_DATA*mdx, int, int, int );
/**static**/ void set_freq(MDX_DATA*mdx, int, int );
/**static**/ void set_opm_reg(MDX_DATA*mdx, int, int, int );
/**static**/ void set_fade_out(MDX_DATA*mdx, int );
/**static**/ void send_sync(MDX_DATA*mdx, int );
/**static**/ void recv_sync(MDX_DATA*mdx, int );
/**static**/ void set_plfo_onoff(MDX_DATA*mdx, int, int );
/**static**/ void set_plfo(MDX_DATA*mdx, int, int, int, int, int, int );
/**static**/ void set_alfo_onoff(MDX_DATA*mdx, int, int );
/**static**/ void set_alfo(MDX_DATA*mdx, int, int, int, int, int, int );
/**static**/ void set_hlfo_onoff(MDX_DATA*mdx, int, int );
/**static**/ void set_hlfo(MDX_DATA*mdx, int, int, int, int, int, int );
/**static**/ void set_lfo_delay(MDX_DATA*mdx, int, int );
/**static**/ void do_quantize(MDX_DATA*mdx, int, int );
