#include "app.h"///

/**INLINE**/ void lfo_calc(YM2151*PSG/**void**/)
{
unsigned int phase, lfx;

	if (PSG->test&2)
	{
		PSG->LFOphase = 0;
		phase = PSG->LFOwave;
	}
	else
	{
		phase = (PSG->LFOphase>>LFO_SH) & LFO_MASK;
		phase = phase*2 + PSG->LFOwave;
	}

	lfx = lfo_tab[phase] + PSG->AMD;

	PSG->LFA = 0;
	if (lfx < TL_TAB_LEN)
		PSG->LFA = TL_TAB[ lfx ];

	lfx = lfo_tab[phase+1] + PSG->PMD;

	PSG->LFP = 0;
	if (lfx < TL_TAB_LEN)
		PSG->LFP = TL_TAB[ lfx ];
}


/**INLINE**/ void calc_lfo_pm(YM2151*PSG,OscilRec *op)
{
signed int mod_ind, pom;

	mod_ind = PSG->LFP; /* -128..+127 (8bits signed)*/
	if (op->PMS < 6)
		mod_ind >>= (6 - op->PMS);
	else
		mod_ind <<= (op->PMS - 5);

	if (mod_ind)
	{
		unsigned int kc_channel;

		kc_channel = op->KCindex + mod_ind;

		pom = ( (PSG->freq[ kc_channel + op->DT2 ] + op->DT1v) * op->MUL ) >> 1;
		op->phase += (pom - op->freq);

		op+=8;
		pom = ( (PSG->freq[ kc_channel + op->DT2 ] + op->DT1v) * op->MUL ) >> 1;
		op->phase += (pom - op->freq);

		op+=8;
		pom = ( (PSG->freq[ kc_channel + op->DT2 ] + op->DT1v) * op->MUL ) >> 1;
		op->phase += (pom - op->freq);

		op+=8;
		pom = ( (PSG->freq[ kc_channel + op->DT2 ] + op->DT1v) * op->MUL ) >> 1;
		op->phase += (pom - op->freq);
	}
}


/**INLINE**/ signed int op_calc(OscilRec * OP, unsigned int env, signed int pm)
{
	unsigned int p;

	p = (env<<3) + sin_tab[ ( ((signed int)((OP->phase & ~FREQ_MASK) + (pm<<15))) >> FREQ_SH ) & SIN_MASK ];

	if (p >= TL_TAB_LEN)
		return 0;

	return TL_TAB[p];
}

/**INLINE**/ signed int op_calc1(OscilRec * OP, unsigned int env, signed int pm)
{
	unsigned int p;
	signed int i;

	i = (OP->phase & ~FREQ_MASK) + pm;

/*logerror("i=%08x (i>>16)&511=%8i phase=%i [pm=%08x] ",i, (i>>16)&511, OP->phase>>FREQ_SH, pm);*/

	p = (env<<3) + sin_tab[ (i>>FREQ_SH) & SIN_MASK];

/*logerror("(p&255=%i p>>8=%i) out= %i\n", p&255,p>>8, TL_TAB[p&255]>>(p>>8) );*/

	if (p >= TL_TAB_LEN)
		return 0;

	return TL_TAB[p];
}


#define volume_calc(OP) (OP->TL + (((unsigned int)OP->volume)>>ENV_SH) + (AM & OP->AMSmask))

/**INLINE**/ void chan_calc(YM2151*PSG,unsigned int chan)
{
OscilRec *OP;
unsigned int env;
unsigned int AM;

	chanout[chan]= c1 = m2 = c2 = 0;
	AM = 0;

	OP = &PSG->Oscils[chan]; /*M1*/

	if (OP->AMS)
		AM = PSG->LFA << (OP->AMS-1);

	if (OP->PMS)
		calc_lfo_pm(PSG,OP);

	env = volume_calc(OP);
	{
		signed int out;

		out = OP->FB0 + OP->FB;
		OP->FB0 = OP->FB;

		if (!OP->connect)
			/* algorithm 5 */
			c1 = m2 = c2 = OP->FB0;
		else
			/* other algorithms */
			*OP->connect = OP->FB0;

		OP->FB = 0;

		if (env < ENV_QUIET)
			OP->FB = op_calc1(OP, env, (out<<OP->FeedBack) );
	}

	OP += 16; /*C1*/
	env = volume_calc(OP);
	if (env < ENV_QUIET)
		*OP->connect += op_calc(OP, env, c1);

	OP -= 8;  /*M2*/
	env = volume_calc(OP);
	if (env < ENV_QUIET)
		*OP->connect += op_calc(OP, env, m2);

	OP += 16; /*C2*/
	env = volume_calc(OP);
	if (env < ENV_QUIET)
		chanout[chan] += op_calc(OP, env, c2);

}
/**INLINE**/ void chan7_calc(YM2151*PSG/**void**/)
{
OscilRec *OP;
unsigned int env;
unsigned int AM;

	chanout[7]= c1 = m2 = c2 = 0;
	AM = 0;

	OP = &PSG->Oscils[7]; /*M1*/

	if (OP->AMS)
		AM = PSG->LFA << (OP->AMS-1);

	if (OP->PMS)
		calc_lfo_pm(PSG,OP);

	env = volume_calc(OP);
	{
		signed int out;

		out = OP->FB0 + OP->FB;
		OP->FB0 = OP->FB;

		if (!OP->connect)
			/* algorithm 5 */
			c1 = m2 = c2 = OP->FB0;
		else
			/* other algorithms */
			*OP->connect = OP->FB0;

		OP->FB = 0;

		if (env < ENV_QUIET)
			OP->FB = op_calc1(OP, env, (out<<OP->FeedBack) );
	}

	OP += 16; /*C1*/
	env = volume_calc(OP);
	if (env < ENV_QUIET)
		*OP->connect += op_calc(OP, env, c1);

	OP -= 8;  /*M2*/
	env = volume_calc(OP);
	if (env < ENV_QUIET)
		*OP->connect += op_calc(OP, env, m2);

	OP += 16; /*C2*/
	env = volume_calc(OP);

	if (PSG->noise & 0x80)
	{
		unsigned int noiseout;

		noiseout = 0;
		if (env < 0x3ff)
			noiseout = (env ^ 0x3ff) * 2; /*range of the YM2151 noise output is -2044 to 2040*/
		chanout[7] += ((PSG->noiseRNG&0x10000) ? noiseout: -noiseout); /*bit 16 -> output*/
	}
	else
	{
		if (env < ENV_QUIET)
			chanout[7] += op_calc(OP, env, c2);
	}

}

/**INLINE**/ void advance(YM2151*PSG/**void**/)
{
OscilRec *op;
int i;

	if (!(PSG->test&2))
		PSG->LFOphase += PSG->LFOfrq;

	/* The Noise Generator of the YM2151 is 17-bit shift register.
	** Input to the bit16 is negated (bit0 XOR bit3) (EXNOR).
	** Output of the register is negated (bit0 XOR bit3).
	** Simply use bit16 as the noise output.
	*/
	PSG->noise_p += PSG->noise_f;
	i = (PSG->noise_p>>16);		/*number of events (shifts of the shift register)*/
	PSG->noise_p &= 0xffff;
	while (i)
	{
		unsigned int j;
		j = ( (PSG->noiseRNG ^ (PSG->noiseRNG>>3) ) & 1) ^ 1;
		PSG->noiseRNG = (j<<16) | (PSG->noiseRNG>>1);
		i--;
	}

	/* In real it seems that CSM keyon line is ORed with the KO line inside of the chip.
	** This causes it to only work when KO is off, ie. 0
	** Below is my implementation only.
	*/
	if (PSG->CSMreq) /*CSM KEYON/KEYOFF seqeunce request*/
	{
		if (PSG->CSMreq==2)	/*KEYON*/
		{
			op = &PSG->Oscils[0]; /*CH 0 M1*/
			i = 32;
			do
			{
				if (op->key==0) /*_ONLY_ when KEY is OFF (checked)*/
				{
					op->phase = 0;
					op->state = EG_ATT;
				}
				op++;
				i--;
			}while (i);
			PSG->CSMreq = 1;
		}
		else					/*KEYOFF*/
		{
			op = &PSG->Oscils[0]; /*CH 0 M1*/
			i = 32;
			do
			{
				if (op->key==0) /*_ONLY_ when KEY is OFF (checked)*/
				{
					if (op->state>EG_REL)
						op->state = EG_REL;
				}
				op++;
				i--;
			}while (i);
			PSG->CSMreq = 0;
		}
	}

	op = &PSG->Oscils[0]; /*CH0 M1*/
	i = 32;
	do
	{
		op->phase += op->freq;

		switch(op->state)
		{
		case EG_ATT:	/*attack phase*/
		{
			signed int step;

			step = op->volume;
			op->volume -= op->delta_AR;
			step = (step>>ENV_SH) - (((unsigned int)op->volume)>>ENV_SH); /*number of levels passed since last time*/
			if (step > 0)
			{
				signed int tmp_volume;

				tmp_volume = op->volume + (step<<ENV_SH); /*adjust by number of levels*/
				do
				{
					tmp_volume = tmp_volume - (1<<ENV_SH) - ((tmp_volume>>4) & ~ENV_MASK);
					if (tmp_volume <= MIN_ATT_INDEX)
						break;
					step--;
				}while(step);
				op->volume = tmp_volume;
			}

			if (op->volume <= MIN_ATT_INDEX)
			{
				if (op->volume < 0)
					op->volume = 0; /*this is not quite correct (checked)*/
				op->state = EG_DEC;
			}
		}
		break;

		case EG_DEC:	/*decay phase*/
			if ( (op->volume += op->delta_D1R) >= op->D1L )
			{
				op->volume = op->D1L; /*this is not quite correct (checked)*/
				op->state = EG_SUS;
			}
		break;

		case EG_SUS:	/*sustain phase*/
			if ( (op->volume += op->delta_D2R) > MAX_ATT_INDEX )
			{
				op->state = EG_OFF;
				op->volume = MAX_ATT_INDEX;
			}
		break;

		case EG_REL:	/*release phase*/
			if ( (op->volume += op->delta_RR) > MAX_ATT_INDEX )
			{
				op->state = EG_OFF;
				op->volume = MAX_ATT_INDEX;
			}
		break;
		}
		op++;
		i--;
	}while (i);
}

/*
** Generate samples for one of the YM2151's
**
** 'num' is the number of virtual YM2151
** '**buffers' is table of pointers to the buffers: left and right
** 'length' is the number of samples that should be generated
*/
void YM2151UpdateOne(/**int num,**/ INT16 /** * **/*buffers, int length)
{
	YM2151*PSG=&YMPSG;
	signed int PAN[8] = {///
		PSG->PAN[ 0] | PSG->PAN[ 1],///
		PSG->PAN[ 2] | PSG->PAN[ 3],///
		PSG->PAN[ 4] | PSG->PAN[ 5],///
		PSG->PAN[ 6] | PSG->PAN[ 7],///
		PSG->PAN[ 8] | PSG->PAN[ 9],///
		PSG->PAN[10] | PSG->PAN[11],///
		PSG->PAN[12] | PSG->PAN[13],///
		PSG->PAN[14] | PSG->PAN[15],///
	};///

	int i;
	signed int out/**l,outr**/;
///	SAMP *bufL, *bufR;

///	bufL = buffers[0];
///	bufR = buffers[1];

///	PSG = &YMPSG[num];

///	#ifdef USE_MAME_TIMERS
///		/* ASG 980324 - handled by real timers now */
///	#else
	if (PSG->TimB)
	{
		PSG->TimBVal -= ( length << TIMER_SH );
		if (PSG->TimBVal<=0)
		{
			PSG->TimBVal += PSG->TimerB[ PSG->TimBIndex ];
			if ( PSG->IRQenable & 0x08 )
			{
///				int oldstate = PSG->status & 3;
				PSG->status |= 2;
///				if ((!oldstate) && (PSG->irqhandler)) (*PSG->irqhandler)(1);
			}
		}
	}
///	#endif

	for (i=0; i<length; i++)
	{

		chan_calc(PSG,0);
///		SAVE_SINGLE_CHANNEL(0)
		chan_calc(PSG,1);
///		SAVE_SINGLE_CHANNEL(1)
		chan_calc(PSG,2);
///		SAVE_SINGLE_CHANNEL(2)
		chan_calc(PSG,3);
///		SAVE_SINGLE_CHANNEL(3)
		chan_calc(PSG,4);
///		SAVE_SINGLE_CHANNEL(4)
		chan_calc(PSG,5);
///		SAVE_SINGLE_CHANNEL(5)
		chan_calc(PSG,6);
///		SAVE_SINGLE_CHANNEL(6)
		chan7_calc(PSG);
///		SAVE_SINGLE_CHANNEL(7)

///		SAVE_ALL_CHANNELS

///		outl = chanout[0] & PSG->PAN[0];
///		outr = chanout[0] & PSG->PAN[1];
///		outl += (chanout[1] & PSG->PAN[2]);
///		outr += (chanout[1] & PSG->PAN[3]);
///		outl += (chanout[2] & PSG->PAN[4]);
///		outr += (chanout[2] & PSG->PAN[5]);
///		outl += (chanout[3] & PSG->PAN[6]);
///		outr += (chanout[3] & PSG->PAN[7]);
///		outl += (chanout[4] & PSG->PAN[8]);
///		outr += (chanout[4] & PSG->PAN[9]);
///		outl += (chanout[5] & PSG->PAN[10]);
///		outr += (chanout[5] & PSG->PAN[11]);
///		outl += (chanout[6] & PSG->PAN[12]);
///		outr += (chanout[6] & PSG->PAN[13]);
///		outl += (chanout[7] & PSG->PAN[14]);
///		outr += (chanout[7] & PSG->PAN[15]);
		out  = chanout[0] & PAN[0];///
		out += chanout[1] & PAN[1];///
		out += chanout[2] & PAN[2];///
		out += chanout[3] & PAN[3];///
		out += chanout[4] & PAN[4];///
		out += chanout[5] & PAN[5];///
		out += chanout[6] & PAN[6];///
		out += chanout[7] & PAN[7];///
		out<<=1;///ʑ

///		out/**l**/ >>= FINAL_SH;
///		outr >>= FINAL_SH;
		if (out/**l**/ > MAXOUT) out/**l**/ = MAXOUT;
			else if (out/**l**/ < MINOUT) out/**l**/ = MINOUT;
///		if (outr > MAXOUT) outr = MAXOUT;
///			else if (outr < MINOUT) outr = MINOUT;
///		((SAMP*)bufL)[i] = (SAMP)outl;
///		((SAMP*)bufR)[i] = (SAMP)outr;
		*buffers++ = (SAMP)out;///

///		#ifdef USE_MAME_TIMERS
///		/* ASG 980324 - handled by real timers now */
///		#else
		/* calculate timer A */
		if (PSG->TimA)
		{
			PSG->TimAVal -= ( 1 << TIMER_SH );
			if (PSG->TimAVal <= 0)
			{
				PSG->TimAVal += PSG->TimerA[ PSG->TimAIndex ];
				if (PSG->IRQenable & 0x04)
				{
///					int oldstate = PSG->status & 3;
					PSG->status |= 1;
///					if ((!oldstate) && (PSG->irqhandler)) (*PSG->irqhandler)(1);
				}
				if (PSG->IRQenable & 0x80)
					PSG->CSMreq = 2; /*request KEYON/KEYOFF sequence*/
			}
		}
///		#endif

		lfo_calc(PSG);
		advance(PSG);
	}
}

/**INLINE**/ void refresh_EG( YM2151 *chip, OscilRec * op)
{
	unsigned int kc;
	unsigned int v;

	kc = op->KC;

	/*v = 32 + 2*RATE + RKS (max 126)*/

	v = kc >> op->KS;
	if ((op->AR+v) < 32+62)
		op->delta_AR  = chip->EG_tab[ op->AR + v];
	else
		op->delta_AR  = MAX_ATT_INDEX+1;
	op->delta_D1R = chip->EG_tab[op->D1R + v];
	op->delta_D2R = chip->EG_tab[op->D2R + v];
	op->delta_RR  = chip->EG_tab[ op->RR + v];

	op+=8;

	v = kc >> op->KS;
	if ((op->AR+v) < 32+62)
		op->delta_AR  = chip->EG_tab[ op->AR + v];
	else
		op->delta_AR  = MAX_ATT_INDEX+1;
	op->delta_D1R = chip->EG_tab[op->D1R + v];
	op->delta_D2R = chip->EG_tab[op->D2R + v];
	op->delta_RR  = chip->EG_tab[ op->RR + v];

	op+=8;

	v = kc >> op->KS;
	if ((op->AR+v) < 32+62)
		op->delta_AR  = chip->EG_tab[ op->AR + v];
	else
		op->delta_AR  = MAX_ATT_INDEX+1;
	op->delta_D1R = chip->EG_tab[op->D1R + v];
	op->delta_D2R = chip->EG_tab[op->D2R + v];
	op->delta_RR  = chip->EG_tab[ op->RR + v];

	op+=8;

	v = kc >> op->KS;
	if ((op->AR+v) < 32+62)
		op->delta_AR  = chip->EG_tab[ op->AR + v];
	else
		op->delta_AR  = MAX_ATT_INDEX+1;
	op->delta_D1R = chip->EG_tab[op->D1R + v];
	op->delta_D2R = chip->EG_tab[op->D2R + v];
	op->delta_RR  = chip->EG_tab[ op->RR + v];

}

/**static**/ int set_new_event(MDX_DATA*mdx, int t ) {

  int ptr;
  unsigned char *data;
  int count;
  int follower;

  data = mdx->data;
  ptr = mdx->track[t].current_mml_ptr;
  count = 0;
  follower = 0;

///#if 0
///  if ( ptr+1 <= mdx->length && t>7 ) {
///    fprintf(stderr,"%2d %2x %2x\n",t,data[ptr],data[ptr+1]);fflush(stderr);
///  }
///#endif

  if ( data[ptr] <= MDX_MAX_REST ) {  /* rest */
    note_off(mdx,t);
    count = data[ptr]+1;
    mdx->track[t].gate = count+1;
    follower=0;

  } else if ( data[ptr] <= MDX_MAX_NOTE ) { /* note */
    note_on(mdx, t, data[ptr]);
    count = data[ptr+1]+1;
    do_quantize(mdx, t, count );
    follower = 1;

  } else {
    switch ( data[ptr] ) {

    case MDX_SET_TEMPO:
      set_tempo(mdx, data[ptr+1] );
      follower = 1;
      break;

    case MDX_SET_OPM_REG:
      set_opm_reg(mdx, t, data[ptr+1], data[ptr+2] );
      follower = 2;
      break;

    case MDX_SET_VOICE:
      set_voice(mdx, t, data[ptr+1] );
      follower = 1;
      break;

    case MDX_SET_PHASE:
      set_phase(mdx, t, data[ptr+1] );
      follower = 1;
      break;

    case MDX_SET_VOLUME:
      set_volume(mdx, t, data[ptr+1] );
      follower = 1;
      break;

    case MDX_VOLUME_DEC:
      dec_volume(mdx, t );
      follower = 0;
      break;

    case MDX_VOLUME_INC:
      inc_volume(mdx, t );
      follower = 0;
      break;

    case MDX_SET_QUANTIZE:
      set_quantize(mdx, t, data[ptr+1] );
      follower = 1;
      break;

    case MDX_SET_KEYOFF:
      set_keyoff(mdx, t );
      follower = 0;
      break;

    case MDX_REPEAT_START:
      mdx->track[t].loop_counter[mdx->track[t].loop_depth] = data[ptr+1];
      if ( mdx->track[t].loop_depth < MDX_MAX_LOOP_DEPTH )
	mdx->track[t].loop_depth++;
      follower = 2;
      break;

    case MDX_REPEAT_END:
      if (--mdx->track[t].loop_counter[mdx->track[t].loop_depth-1] == 0 ) {
	if ( --mdx->track[t].loop_depth < 0 ) mdx->track[t].loop_depth=0;
      } else {
	if ( data[ptr+1] >= 0x80 ) {
	  ptr = ptr+2 - (0x10000-(data[ptr+1]*256 + data[ptr+2])) - 2;
	} else {
	  ptr = ptr+2 + data[ptr+1]*256 + data[ptr+2] - 2;
	}
      }
      follower = 2;
      break;

    case MDX_REPEAT_BREAK:
      if ( mdx->track[t].loop_counter[mdx->track[t].loop_depth-1] == 1 ) {
	if ( --mdx->track[t].loop_depth < 0 ) mdx->track[t].loop_depth=0;
	ptr = ptr+2 + data[ptr+1]*256 + data[ptr+2] -2 +2;
      }
      follower = 2;
      break;

    case MDX_SET_DETUNE:
      set_detune(mdx, t, data[ptr+1], data[ptr+2] );
      follower = 2;
      break;

    case MDX_SET_PORTAMENT:
      set_portament(mdx, t, data[ptr+1], data[ptr+2] );
      follower = 2;
      break;

    case MDX_DATA_END:
      if ( data[ptr+1] == 0x00 ) {
	count = -1;
	note_off(mdx,t);
	follower = 1;
      } else {
	ptr = ptr+2 - (0x10000-(data[ptr+1]*256 + data[ptr+2])) - 2;
	mdx->track[t].infinite_loop_times++;
	follower = 2;
      }
      break;
 
    case MDX_KEY_ON_DELAY:
      follower = 1;
      break;

    case MDX_SEND_SYNC:
      send_sync(mdx, data[ptr+1] );
      follower = 1;
      break;

    case MDX_RECV_SYNC:
      recv_sync(mdx, t );
      follower = 0;
      count = 1;
      break;

    case MDX_SET_FREQ:
      set_freq(mdx, t, data[ptr+1] );
      follower = 1;
      break;

    case MDX_SET_PLFO:
      if ( data[ptr+1] == 0x80 || data[ptr+1] == 0x81 ) {
	set_plfo_onoff(mdx, t, data[ptr+1]-0x80 );
	follower = 1;
      } else {
	set_plfo(mdx, t,
		  data[ptr+1], data[ptr+2], data[ptr+3],
		  data[ptr+4], data[ptr+5] );
	follower = 5;
      }
      break;

    case MDX_SET_ALFO:
      if ( data[ptr+1] == 0x80 || data[ptr+1] == 0x81 ) {
	set_alfo_onoff(mdx, t, data[ptr+1]-0x80 );
	follower = 1;
      } else {
	set_alfo(mdx, t,
		  data[ptr+1], data[ptr+2], data[ptr+3],
		  data[ptr+4], data[ptr+5] );
	follower = 5;
      }
      break;

    case MDX_SET_OPMLFO:
      if ( data[ptr+1] == 0x80 || data[ptr+1] == 0x81 ) {
	set_hlfo_onoff(mdx, t, data[ptr+1]-0x80 );
	follower = 1;
      } else {
	set_hlfo(mdx, t,
		  data[ptr+1], data[ptr+2], data[ptr+3],
		  data[ptr+4], data[ptr+5] );
	follower = 5;
      }
      break;

    case MDX_SET_LFO_DELAY:
      set_lfo_delay(mdx, t, data[ptr+1] );
      follower = 1;
      break;

    case MDX_SET_PCM8_MODE:
      follower = 0;
      break;

    case MDX_FADE_OUT:
      if ( data[ptr+1]==0x00 ) {
	follower = 1;
	set_fade_out(mdx, 5 );
      } else {
	follower = 2;
	set_fade_out(mdx, data[ptr+2] );
      }
      break;

    default:
      count = -1;
      break;
    }
  }

  ptr += 1+follower;
  mdx->track[t].current_mml_ptr = ptr;

  return count;
}

void
stream_callback_sub(short* dst, short* src)
{
	int i;
	short v;

	for(i = 0; i < BLKS/PB_RATE_DIV; i++) {
		v = *src++;
		#if PB_RATE_DIV == 4
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		#elif PB_RATE_DIV == 5
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		#elif PB_RATE_DIV == 8
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		*dst++ = v;
		#else
		#error
		#endif
	}
}

