/*
  MDXplay : MDX file parser

  Made by Daisuke Nagano <breeze.nagano@nifty.ne.jp>
  Jan.13.1999

  reference : mdxform.doc  ( KOUNO Takeshi )
            : MXDRVWIN.pas ( monlight@tkb.att.ne.jp )
 */
#include "app.h"

///#ifdef HAVE_CONFIG_H
///# include "config.h"
///#endif /* HAVE_CONFIG_H */

///#include <stdio.h>
///#include <stdlib.h>

///#ifdef STDC_HEADERS
///# include <string.h>
///#else
///# ifndef HAVE_STRCHR
///#  define strchr index
///#  define strrchr rindex
///# endif
///#endif

///#ifdef HAVE_UNISTD_H
///# include <unistd.h>
///# include <sys/types.h>
///#endif

///#include <sys/ipc.h>
///#include <sys/shm.h>
///#include <sys/stat.h>

///#ifdef HAVE_JCONV_SUPPORT
///# include <jconv.h>
///#endif

///#include "version.h"
///#include "mdx.h"
///#include "mdxopl3.h"
///#include "gettext_wrapper.h"

/* ------------------------------------------------------------------ */
/* local functions */

///static void error_file( void );

/* ------------------------------------------------------------------ */

/**MDX_DATA * **/int mdx_open_mdx( char *name ) {
  MDX_DATA *mdx=&mdx_data;

  int i/**,j**/;
  int ptr;
  unsigned char *buf;
///  FILE *fp;
///  struct stat stt;
///  char *shm;
  FILEACC fa;///

  memset(mdx, 0, sizeof(MDX_DATA));///

  /* allocate work area */

///  shm = getenv(MDX_EXTERNAL_WORK_SHMID);
///  if ( shm != NULL )
///    mdx = (MDX_DATA *)shmat( atoi(shm), 0, 0 );
///  else
///    mdx = (MDX_DATA *)malloc(sizeof(MDX_DATA));
///  if ( mdx == NULL ) return NULL;

  /* data read */

///  if ( stat( name, &stt ) ) return NULL;
///  fp = fopen( name, "r" );
///  if ( fp == NULL ) return NULL;
  if(pceFileOpen(&fa, name, FOMD_RD) != 0) return -1;///
  if(fa.fsize > MAX_SONG_SIZE) { pceFileClose(&fa); return -2; }///

  mdx->length = /**stt.st_size**/fa.fsize;
  mdx->data = mdx_song/**(unsigned char *)malloc(sizeof(unsigned char)*mdx->length)**/;
///  fread( mdx->data, 1, mdx->length, fp );
///  fclose(fp);
  for(i = 0; i < fa.fsize; ) {///
    i += pceFileReadSct(&fa, mdx->data+i, i/BLOCKSIZE, BLOCKSIZE);///
  }///
  pceFileClose(&fa);///

  /* title parsing */

///  for ( i=0 ; i<MDX_MAX_TITLE_LENGTH ; i++ ) {
///    mdx->data_title[i] = '\0';
///  }
  i=0;
  ptr=0;
  buf = mdx->data;
///  mdx->data_title[i]=0;
  while(1) {
    if ( buf[ptr+0] == 0x0d &&
	 buf[ptr+1] == 0x0a &&
	 buf[ptr+2] == 0x1a ) break;

///    mdx->data_title[i++]=buf[ptr++];  /* warning! this text is SJIS */
///    if ( i>=MDX_MAX_TITLE_LENGTH ) i--;
    ptr++;///
    if ( ptr > mdx->length ) /**error_file()**/return -3;
  }
///  mdx->data_title[i++]=0;


  /* pdx name */

  ptr+=3;
///  for ( i=0 ; i<MDX_MAX_PDX_FILENAME_LENGTH ; i++ ) {
///    mdx->pdx_name[i]='\0';
///  }
  i=0;
///  j=0;
///  mdx->haspdx=FLAG_FALSE;
  while(1) {
    if ( buf[ptr] == 0x00 ) break;

///    mdx->haspdx=FLAG_TRUE;
///    mdx->pdx_name[i++] = buf[ptr++];
///    if ( strcasecmp( ".pdx", (buf+ptr-1) )==0 ) j=1;
///    if ( i>= MDX_MAX_PDX_FILENAME_LENGTH ) i--;
    ptr++;///
    if ( ptr > mdx->length ) /**error_file()**/return -4;
  }
///  if ( mdx->haspdx==FLAG_TRUE && j==0 ) {
///    mdx->pdx_name[i+0] = '.';
///    mdx->pdx_name[i+1] = 'p';
///    mdx->pdx_name[i+2] = 'd';
///    mdx->pdx_name[i+3] = 'x';
///  }

  /* get voice data offset */

  ptr++;
  mdx->base_pointer = ptr;
  mdx->voice_data_offset =
    (unsigned int)buf[ptr+0]*256 +
    (unsigned int)buf[ptr+1] + mdx->base_pointer;

  if ( mdx->voice_data_offset > mdx->length ) /**error_file()**/return -5;

   /* get MML data offset */

  mdx->mml_data_offset[0] =
    (unsigned int)buf[ptr+2+0] * 256 +
    (unsigned int)buf[ptr+2+1] + mdx->base_pointer;
  if ( mdx->mml_data_offset[0] > mdx->length ) /**error_file()**/return -6;

///  if ( buf[mdx->mml_data_offset[0]] == MDX_SET_PCM8_MODE ) {
///    mdx->ispcm8mode = 1;
///    mdx->tracks = 16;
///  } else {
///    mdx->ispcm8mode = 0;
    mdx->tracks = 9;
///  }

  for ( i=0 ; i<mdx->tracks ; i++ ) {
    mdx->mml_data_offset[i] =
      (unsigned int)buf[ptr+i*2+2+0] * 256 +
      (unsigned int)buf[ptr+i*2+2+1] + mdx->base_pointer;
    if ( mdx->mml_data_offset[i] > mdx->length ) /**error_file()**/return -7;
  }


  /* init. configuration */

///  mdx->is_use_pcm8 = FLAG_TRUE;
///  mdx->is_use_fm   = FLAG_TRUE;
///  mdx->is_use_opl3 = FLAG_TRUE;

///  i = strlen(VERSION_TEXT1);
///  if ( i > MDX_VERSION_TEXT_SIZE ) i=MDX_VERSION_TEXT_SIZE;
///  strncpy( mdx->version_1, VERSION_TEXT1, i );
///  i = strlen(VERSION_TEXT2);
///  if ( i > MDX_VERSION_TEXT_SIZE ) i=MDX_VERSION_TEXT_SIZE;
///  strncpy( mdx->version_2, VERSION_TEXT2, i );

///  return mdx;
  if(mdx_get_voice_parameter() != 0) return -8;///
  if(mdx_init_track_work_area_ym2151() != 0) return -9;///
  ym2151_reg_init();
  return 0;///
}

///int mdx_close_mdx ( MDX_DATA *mdx ) {
///
///  if ( mdx == NULL ) return 1;
///
///  if ( mdx->data != NULL ) free(mdx->data);
///  free(mdx);
///
///  return 0;
///}


int mdx_get_voice_parameter(/** MDX_DATA *mdx **/) {
  MDX_DATA*mdx=&mdx_data;

  int i;
  int ptr;
  int num;
///  int sum;
  unsigned char *buf;

  ptr = mdx->voice_data_offset;
  buf = mdx->data;

  while ( ptr < mdx->length ) {

    if ( mdx->length-ptr < 27 ) break;

    num = buf[ptr++];
    if ( num >= MDX_MAX_VOICE_NUMBER ) return 1;

    mdx->voice[num].v0 = buf[ptr];

    mdx->voice[num].con = buf[ptr  ]&0x07;
    mdx->voice[num].fl  = (buf[ptr++] >> 3)&0x07;
    mdx->voice[num].slot_mask = buf[ptr++];

    /* DT1 & MUL */
    for ( i=0 ; i<4 ; i++ ) {
      mdx->voice[num].v1[i] = buf[ptr];

      mdx->voice[num].mul[i] = buf[ptr] & 0x0f;
      mdx->voice[num].dt1[i] = (buf[ptr] >> 4)&0x07;
      ptr++;
    }
    /* TL */
    for ( i=0 ; i<4 ; i++ ) {
      mdx->voice[num].v2[i] = buf[ptr];

      mdx->voice[num].tl[i] = buf[ptr];
      ptr++;
    }
    /* KS & AR */
    for ( i=0 ; i<4 ; i++ ) {
      mdx->voice[num].v3[i] = buf[ptr];

      mdx->voice[num].ar[i] = buf[ptr] & 0x1f;
      mdx->voice[num].ks[i] = (buf[ptr] >> 6)&0x03;
      ptr++;
    }
    /* AME & D1R */
    for ( i=0 ; i<4 ; i++ ) {
      mdx->voice[num].v4[i] = buf[ptr];

      mdx->voice[num].d1r[i] = buf[ptr] & 0x1f;
      mdx->voice[num].ame[i] = (buf[ptr] >> 7)&0x01;
      ptr++;
    }
    /* DT2 & D2R */
    for ( i=0 ; i<4 ; i++ ) {
      mdx->voice[num].v5[i] = buf[ptr];

      mdx->voice[num].d2r[i] = buf[ptr] & 0x1f;
      mdx->voice[num].dt2[i] = (buf[ptr] >> 6)&0x03;
      ptr++;
    }
    /* SL & RR */
    for ( i=0 ; i<4 ; i++ ) {
      mdx->voice[num].v6[i] = buf[ptr];

      mdx->voice[num].rr[i] = buf[ptr] & 0x0f;
      mdx->voice[num].sl[i] = (buf[ptr] >> 4)&0x0f;
      ptr++;
    }
///    if ( mdx->dump_voice == FLAG_TRUE ) {
///      fprintf(stdout, "( @%03d, \n", num);
///      fprintf(stdout, "#\t AR  D1R  D2R   RR   SL   TL   KS  MUL  DT1  DT2  AME\n");
///      for ( i=0 ; i<4 ; i++ ) {
///	fprintf(stdout, "\t%3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d,\n",
///		mdx->voice[num].ar[i],
///		mdx->voice[num].d1r[i],
///		mdx->voice[num].d2r[i],
///		mdx->voice[num].rr[i],
///		mdx->voice[num].sl[i],
///		mdx->voice[num].tl[i],
///		mdx->voice[num].ks[i],
///		mdx->voice[num].mul[i],
///		mdx->voice[num].dt1[i],
///		mdx->voice[num].dt2[i],
///		mdx->voice[num].ame[i] );
///      }
///      fprintf(stdout, "#\tCON   FL   SM\n");
///      fprintf(stdout, "\t%3d, %3d, %3d )\n",
///	      mdx->voice[num].con,
///	      mdx->voice[num].fl,
///	      mdx->voice[num].slot_mask );
///
///      fprintf(stdout, "[ F0 7D 10 %02X ", num);
///      sum = mdx->voice[num].v0;
///      for ( i=0 ; i<4 ; i++ ) {
///	fprintf(stdout, "%02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X ",
///		mdx->voice[num].ar[i],
///		mdx->voice[num].d1r[i],
///		mdx->voice[num].d2r[i],
///		mdx->voice[num].rr[i],
///		mdx->voice[num].sl[i],
///		mdx->voice[num].tl[i],
///		mdx->voice[num].ks[i],
///		mdx->voice[num].mul[i],
///		mdx->voice[num].dt1[i],
///		mdx->voice[num].dt2[i],
///		mdx->voice[num].ame[i] );
///	sum += mdx->voice[num].v1[i] + mdx->voice[num].v2[i] + mdx->voice[num].v3[i] + mdx->voice[num].v4[i] + mdx->voice[num].v5[i] + mdx->voice[num].v6[i];
///      }
///      fprintf(stdout, "%02X %02X %02X ",
///	      mdx->voice[num].con,
///	      mdx->voice[num].fl,
///	      mdx->voice[num].slot_mask );
///
///      fprintf(stdout, "%02X F7 ]\n", 0x80-(sum%0x7f));
///      fprintf(stdout, "\n");
///    }
  }

  return 0;
}

/* ------------------------------------------------------------------ */

///int mdx_output_titles( MDX_DATA *mdx ) {
///
///  unsigned char *message;
///
///#ifdef HAVE_JCONV_SUPPORT
///  if ( geteuid() == 0 ) {
///    message = convert_kanji_strict(mdx->data_title,"EUCJP","SJIS");
///  } else {
///    message = convert_kanji_auto(mdx->data_title);
///  }
///#else
///  message = strdup(mdx->data_title);
///#endif
///  if ( message != NULL ) {
///    fprintf(stderr,_("Title:\t%s\n"),message);
///    free(message);
///  }
///
///  return 0;
///}

/* ------------------------------------------------------------------ */

///static void error_file( void ) {
///  error_end(_("Invalid mdx file."));
///}
